permutacija([],[]).
permutacija([G|R], P):-permutacija(R,P1), ubaci(G,P1,P).

ubaci(X, [], [X]).
ubaci(X, [G|R], [X,G|R]).
ubaci(X, [G|R], [G|L1]):- ubaci(X, R, L1).

kombinacija([],0,[]):-!.
kombinacija(L,0,[]):-!.
kombinacija([G|R], N, [G|K]):- N1 is N-1, kombinacija(R,N1,K). 
kombinacija([G|R], N, K):- kombinacija(R,N,K). 

varijacija(L, K, V):- kombinacija(L,K,C), permutacija(C, V).

naivni_sort(L, S):- permutacija(L, S), sortirana(S). 

sortirana([]).
sortirana([X]).
sortirana([G1,G2|R]):- G1 =< G2, sortirana([G2|R]).

ubaci_uredj(X,[],[X]).
ubaci_uredj(X,[G|R],[G|R1]):-X > G, ubaci_uredj(X,R,R1),!.
ubaci_uredj(X,[G|R],[X,G|R]).

ins_sort([],[]).
ins_sort([G|R],S):-ins_sort(R,S1), ubaci_uredj(G,S1,S).

merge_sort([],[]).
merge_sort([X],[X]).
merge_sort(L,S):- podeli(L,L1,L2), merge_sort(L1,S1),
                    merge_sort(L2,S2), merge(S1,S2,S).
                    
podeli([],[],[]).
podeli([X],[X],[]).
podeli([G1,G2|R],[G1|R1],[G2|R2]):-podeli(R,R1,R2).

merge(L,[],L).
merge([],L,L).
merge([G1|R1],[G2|R2],[G1|M]):-G1<G2,!, merge(R1,[G2|R2],M).
merge([G1|R1],[G2|R2],[G2|M]):-merge([G1|R1],R2,M).